Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/browser/BrowserFrame.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/browser/BrowserFrame.java	(revision 6831)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/browser/BrowserFrame.java	(revision 6831)
@@ -0,0 +1,374 @@
+package fr.mael.jiwigo.ui.browser;
+
+import java.awt.AWTEvent;
+import java.awt.BorderLayout;
+import java.awt.Dimension;
+import java.awt.FlowLayout;
+import java.awt.Toolkit;
+import java.awt.event.AWTEventListener;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.awt.event.KeyEvent;
+import java.awt.image.BufferedImage;
+import java.awt.print.PrinterException;
+import java.awt.print.PrinterJob;
+import java.io.File;
+import java.io.IOException;
+import java.net.URL;
+
+import javax.imageio.ImageIO;
+import javax.swing.ImageIcon;
+import javax.swing.JButton;
+import javax.swing.JFileChooser;
+import javax.swing.JFrame;
+import javax.swing.JMenu;
+import javax.swing.JMenuBar;
+import javax.swing.JMenuItem;
+import javax.swing.JPanel;
+import javax.swing.JRootPane;
+import javax.swing.JScrollPane;
+
+import fr.mael.jiwigo.om.Image;
+import fr.mael.jiwigo.transverse.util.ImagesUtil;
+import fr.mael.jiwigo.transverse.util.Messages;
+import fr.mael.jiwigo.transverse.util.Outil;
+import fr.mael.jiwigo.ui.ImagesManagement;
+import fr.mael.jiwigo.ui.comments.CommentsDialog;
+
+/**
+ *    
+   Copyright (c) 2010, Mael
+   All rights reserved.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright
+      notice, this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of jiwigo nor the
+      names of its contributors may be used to endorse or promote products
+      derived from this software without specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+   DISCLAIMED. IN NO EVENT SHALL Mael BE LIABLE FOR ANY
+   DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+   
+ * @author mael
+ * 
+ * Frame de navigation dans les images
+ *
+ */
+public class BrowserFrame extends JFrame implements ActionListener {
+    /**
+     * Logger
+     */
+    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
+	    .getLog(BrowserFrame.class);
+    /**
+     * bouton pour passer à l'image suivante
+     */
+    private JButton next = new JButton();
+    /**
+     * bouton pour passer à l'image précédente
+     */
+    private JButton previous = new JButton();
+    /**
+     * rotation de l'image vers la gauche
+     */
+    private JButton rotateLeft = new JButton();
+    /**
+     * rotation de l'image vers la droite
+     */
+    private JButton rotateRight = new JButton();
+    /**
+     * sauvegarde de l'image
+     */
+    private JButton save = new JButton();
+    /**
+     * affichage des commentaire de l'image
+     */
+    private JButton comment = new JButton();
+    /**
+     * panel contenant tous les boutons précédents
+     */
+    private JPanel panelBoutons;
+
+    /**
+     * Panel qui contient l'image
+     */
+    private BrowserImagePanel imagePanel;
+
+    /**
+     * Menus
+     */
+    private JMenuBar menuBar;
+    private JMenu menuFichier, menuAffichage, menuImage;
+    private JMenuItem menuItemSave, menuItemPrint, menuItemClose, menuItemZoomPlus;
+    private JMenuItem menuItemZoomMoins, menuItemNormal, menuItemFlipH, menuItemFlipV;
+    private JMenuItem menuItemRotationG, menuItemRotationD;
+
+    /**
+     * Listener général. Permet d'ajouter les écouteurs sur les touches
+     * pour la navigation entres les différentes images grace aux touches
+     * droite et gauche.
+     * Je n'ai pas trouvé mieux que de faire ce listener général.
+     * Il est instancié et ajouté à la création de la frame, et retiré lorsqu'on la quitte
+     */
+    private AWTEventListener generalListener;
+
+    public BrowserFrame(Image image) {
+	this.setIconImage(java.awt.Toolkit.getDefaultToolkit().getImage(Outil.getURL("fr/mael/jiwigo/img/icon.png")));
+	this.setTitle(Messages.getMessage("titleBrowser"));
+	panelBoutons = new JPanel(new FlowLayout());
+	//ajout des images sur les boutons
+	next.setIcon(new ImageIcon(Outil.getURL("fr/mael/jiwigo/img/next.png")));
+	previous.setIcon(new ImageIcon(Outil.getURL("fr/mael/jiwigo/img/previous.png")));
+	rotateLeft.setIcon(new ImageIcon(Outil.getURL("fr/mael/jiwigo/img/left.png")));
+	rotateRight.setIcon(new ImageIcon(Outil.getURL("fr/mael/jiwigo/img/right.png")));
+	save.setIcon(new ImageIcon(Outil.getURL("fr/mael/jiwigo/img/save.png")));
+	comment.setIcon(new ImageIcon(Outil.getURL("fr/mael/jiwigo/img/comment.png")));
+	//on rend les boutons invisibles, pour ne voir que l'image
+	next.setFocusPainted(false);
+	next.setBorderPainted(false);
+	next.setContentAreaFilled(false);
+	previous.setFocusPainted(false);
+	previous.setBorderPainted(false);
+	previous.setContentAreaFilled(false);
+	rotateLeft.setFocusPainted(false);
+	rotateLeft.setBorderPainted(false);
+	rotateLeft.setContentAreaFilled(false);
+	rotateRight.setFocusPainted(false);
+	rotateRight.setBorderPainted(false);
+	rotateRight.setContentAreaFilled(false);
+	save.setFocusPainted(false);
+	save.setBorderPainted(false);
+	save.setContentAreaFilled(false);
+	comment.setFocusPainted(false);
+	comment.setBorderPainted(false);
+	comment.setContentAreaFilled(false);
+	//ajout des action listeners
+	comment.addActionListener(this);
+	save.addActionListener(this);
+	rotateRight.addActionListener(this);
+	rotateLeft.addActionListener(this);
+	previous.addActionListener(this);
+	next.addActionListener(this);
+	//ajout des boutons
+	panelBoutons.add(previous);
+	panelBoutons.add(next);
+	panelBoutons.add(rotateLeft);
+	panelBoutons.add(rotateRight);
+	panelBoutons.add(save);
+	panelBoutons.add(comment);
+
+	BufferedImage img;
+	try {
+	    img = ImageIO.read(new URL(ImagesManagement.getCurrentImage().getUrl()));
+	    imagePanel = new BrowserImagePanel(img);
+	} catch (Exception e1) {
+	    LOG.error(Outil.getStackTrace(e1));
+	}
+
+	this.getContentPane().setLayout(new BorderLayout());
+	JScrollPane scrollpane = new JScrollPane(imagePanel);
+	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
+	this.getRootPane().setWindowDecorationStyle(JRootPane.PLAIN_DIALOG);
+	this.setExtendedState(getExtendedState() | JFrame.MAXIMIZED_BOTH);
+	//	this.setExtendedState(JFrame.ICONIFIED | this.getExtendedState());
+	panelBoutons.add(imagePanel.getSlider());
+	imagePanel.setLayout(new BorderLayout());
+	panelBoutons.setOpaque(false);
+	this.add(scrollpane, BorderLayout.CENTER);
+	this.add(panelBoutons, BorderLayout.SOUTH);
+
+	this.setSize(screenSize);
+	this.setLocationRelativeTo(null);
+	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
+	setUpMenu();
+	//instanciation du listener general
+	this.generalListener = new AWTEventListener() {
+
+	    public void eventDispatched(AWTEvent event) {
+		KeyEvent ke = (KeyEvent) event;
+		if (ke.getID() == KeyEvent.KEY_PRESSED) {
+		    if (ke.getKeyCode() == KeyEvent.VK_RIGHT) {
+			next.doClick();
+		    } else if (ke.getKeyCode() == KeyEvent.VK_LEFT) {
+			previous.doClick();
+		    }
+		}
+	    }
+	};
+	this.setVisible(true);
+
+	//ajout du listener general
+	//Toolkit.getDefaultToolkit().addAWTEventListener(generalListener, AWTEvent.KEY_EVENT_MASK);
+
+    }
+
+    private void setUpMenu() {
+	menuBar = new JMenuBar();
+
+	menuBar = new JMenuBar();
+	menuFichier = new JMenu(Messages.getMessage("imageBrowser_file"));
+	menuAffichage = new JMenu(Messages.getMessage("imageBrowser_display"));
+	menuImage = new JMenu(Messages.getMessage("imageBrowser_image"));
+	menuBar.add(menuFichier);
+	menuBar.add(menuAffichage);
+	menuBar.add(menuImage);
+	menuItemSave = new JMenuItem(Messages.getMessage("imageBrowser_save"), new ImageIcon(Outil
+		.getURL("fr/mael/jiwigo/img/save_mini.png")));
+	menuItemPrint = new JMenuItem(Messages.getMessage("imageBrowser_print"), new ImageIcon(Outil
+		.getURL("fr/mael/jiwigo/img/print.gif")));
+	menuItemClose = new JMenuItem(Messages.getMessage("imageBrowser_close"), new ImageIcon(Outil
+		.getURL("fr/mael/jiwigo/img/close.png")));
+	menuItemZoomPlus = new JMenuItem(Messages.getMessage("imageBrowser_zoomPlus"), new ImageIcon(Outil
+		.getURL("fr/mael/jiwigo/img/zoom_in.png")));
+	menuItemZoomMoins = new JMenuItem(Messages.getMessage("imageBrowser_zoomMoins"), new ImageIcon(Outil
+		.getURL("fr/mael/jiwigo/img/zoom_out.png")));
+	menuItemNormal = new JMenuItem(Messages.getMessage("imageBrowser_zoomNormal"), new ImageIcon(Outil
+		.getURL("fr/mael/jiwigo/img/zoom_n.png")));
+	menuItemFlipH = new JMenuItem(Messages.getMessage("imageBrowser_flipH"), new ImageIcon(Outil
+		.getURL("fr/mael/jiwigo/img/flip_h.png")));
+	menuItemFlipV = new JMenuItem(Messages.getMessage("imageBrowser_flipV"), new ImageIcon(Outil
+		.getURL("fr/mael/jiwigo/img/flip_v.png")));
+	menuItemRotationG = new JMenuItem(Messages.getMessage("imageBrowser_rotationL"), new ImageIcon(Outil
+		.getURL("fr/mael/jiwigo/img/left.png")));
+	menuItemRotationD = new JMenuItem(Messages.getMessage("imageBrowser_rotationR"), new ImageIcon(Outil
+		.getURL("fr/mael/jiwigo/img/right.png")));
+	menuFichier.add(menuItemSave);
+	menuFichier.addSeparator();
+	menuFichier.add(menuItemPrint);
+	menuFichier.addSeparator();
+	menuFichier.add(menuItemClose);
+	menuAffichage.add(menuItemZoomMoins);
+	menuAffichage.add(menuItemNormal);
+	menuAffichage.add(menuItemZoomPlus);
+	menuImage.add(menuItemFlipH);
+	menuImage.add(menuItemFlipV);
+	menuImage.addSeparator();
+	menuImage.add(menuItemRotationG);
+	menuImage.add(menuItemRotationD);
+	menuBar.add(menuFichier);
+	menuBar.add(menuAffichage);
+	menuBar.add(menuImage);
+	menuItemSave.addActionListener(this);
+	menuItemPrint.addActionListener(this);
+	menuItemClose.addActionListener(this);
+	menuItemZoomPlus.addActionListener(this);
+	menuItemZoomMoins.addActionListener(this);
+	menuItemNormal.addActionListener(this);
+	menuItemFlipH.addActionListener(this);
+	menuItemFlipV.addActionListener(this);
+	menuItemRotationG.addActionListener(this);
+	menuItemRotationD.addActionListener(this);
+	this.setJMenuBar(menuBar);
+
+    }
+
+    @Override
+    public void dispose() {
+	super.dispose();
+	//on enleve le listener general
+	Toolkit.getDefaultToolkit().removeAWTEventListener(generalListener);
+    }
+
+    @Override
+    public void actionPerformed(ActionEvent e) {
+	if (e.getSource().equals(comment)) {
+	    new CommentsDialog(this, ImagesManagement.getCurrentImage().getIdentifiant());
+	} else if (e.getSource().equals(save)) {
+	    //ouverture du dialog de sauvegarde d'une image
+	    JFileChooser chooser = new JFileChooser();
+	    if (JFileChooser.APPROVE_OPTION == chooser.showSaveDialog(null)) {
+		File chosenFile = chooser.getSelectedFile();
+		if (chosenFile.getName().endsWith(".png")) {
+		    try {
+			//sauvegarde de l'image
+			ImagesUtil.writeImageToPNG(chosenFile, imagePanel.getImage());
+		    } catch (IOException ex) {
+			LOG.error(Outil.getStackTrace(ex));
+		    }
+		} else {
+		    try {
+			ImagesUtil.writeImageToPNG(new File(chosenFile.getParentFile(), chosenFile.getName() + ".png"),
+				imagePanel.getImage());
+		    } catch (IOException ex) {
+			LOG.error(Outil.getStackTrace(ex));
+		    }
+		}
+	    }
+	} else if (e.getSource().equals(next)) {
+	    //on appelle d'abord la fonction de l'images panel qui increment l'image courante
+	    ImagesManagement.next();
+	    //on rafraichit le panel qui contient l'image
+	    BufferedImage img;
+	    try {
+		img = ImagesManagement.getCurrentBufferedImage();
+		imagePanel.setImage(img);
+	    } catch (Exception e1) {
+		LOG.error(Outil.getStackTrace(e1));
+	    }
+
+	} else if (e.getSource().equals(previous)) {
+	    //on appelle d'abord la fonction de l'images panel qui décrémente l'image courante
+	    ImagesManagement.previous();
+	    //on rafraichit le panel qui contient l'image
+	    BufferedImage img;
+	    try {
+		img = ImagesManagement.getCurrentBufferedImage();
+		imagePanel.setImage(img);
+	    } catch (Exception e1) {
+		LOG.error(Outil.getStackTrace(e1));
+	    }
+
+	} else if (e.getSource().equals(rotateLeft)) {
+	    imagePanel.rotationGauche();
+	} else if (e.getSource().equals(rotateRight)) {
+	    imagePanel.rotationDroite();
+	} else if (e.getSource().equals(menuItemSave)) {
+	    save.doClick();
+	} else if (e.getSource().equals(menuItemClose)) {
+	    this.dispose();
+	} else if (e.getSource().equals(menuItemZoomPlus)) {
+	    imagePanel.zoomIn();
+	} else if (e.getSource().equals(menuItemZoomMoins)) {
+	    imagePanel.zoomOut();
+	} else if (e.getSource().equals(menuItemFlipH)) {
+	    imagePanel.flipH = !imagePanel.flipH;
+	    imagePanel.repaint();
+	    imagePanel.revalidate();
+	} else if (e.getSource().equals(menuItemFlipV)) {
+	    imagePanel.flipV = !imagePanel.flipV;
+	    imagePanel.repaint();
+	    imagePanel.revalidate();
+	} else if (e.getSource().equals(menuItemRotationD)) {
+	    rotateRight.doClick();
+	} else if (e.getSource().equals(menuItemRotationG)) {
+	    rotateLeft.doClick();
+	} else if (e.getSource().equals(menuItemPrint)) {
+	    PrinterJob pj = PrinterJob.getPrinterJob();
+	    pj.setPrintable(imagePanel);
+	    if (pj.printDialog()) {
+		try {
+		    pj.print();
+		} catch (PrinterException ex) {
+		    ex.printStackTrace();
+		}
+	    }
+	} else if (e.getSource().equals(menuItemNormal)) {
+	    imagePanel.zoomNormal();
+	}
+
+    }
+
+}
Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/browser/BrowserImagePanel.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/browser/BrowserImagePanel.java	(revision 6831)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/browser/BrowserImagePanel.java	(revision 6831)
@@ -0,0 +1,244 @@
+package fr.mael.jiwigo.ui.browser;
+
+import java.awt.Dimension;
+import java.awt.Graphics;
+import java.awt.Graphics2D;
+import java.awt.RenderingHints;
+import java.awt.event.MouseWheelEvent;
+import java.awt.event.MouseWheelListener;
+import java.awt.geom.AffineTransform;
+import java.awt.image.BufferedImage;
+import java.awt.print.PageFormat;
+import java.awt.print.Printable;
+import java.awt.print.PrinterException;
+import java.util.Hashtable;
+
+import javax.swing.JLabel;
+import javax.swing.JPanel;
+import javax.swing.JSlider;
+import javax.swing.event.ChangeEvent;
+import javax.swing.event.ChangeListener;
+
+import fr.mael.jiwigo.transverse.util.ImagesUtil;
+
+/**
+   Copyright (c) 2010, Mael
+   All rights reserved.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright
+      notice, this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of jiwigo nor the
+      names of its contributors may be used to endorse or promote products
+      derived from this software without specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+   DISCLAIMED. IN NO EVENT SHALL Mael BE LIABLE FOR ANY
+   DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+   
+ * Panel qui affiche une image
+ * @author mael
+ *
+ */
+public class BrowserImagePanel extends JPanel implements MouseWheelListener, Printable {
+    private BufferedImage image;
+    private double scale = 1.0;
+    boolean flipH = false;
+    boolean flipV = false;
+    private int valueSlider = 16;
+
+    /**
+     * Constructeur
+     * @param image
+     */
+    public BrowserImagePanel(BufferedImage image) {
+	this.image = image;
+	this.addMouseWheelListener(this);
+    }
+
+    /* (non-Javadoc)
+     * @see javax.swing.JComponent#paintComponent(java.awt.Graphics)
+     */
+    protected void paintComponent(Graphics g) {
+	super.paintComponent(g);
+	Graphics2D g2 = (Graphics2D) g;
+	g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
+	double x = (getWidth() - scale * image.getWidth()) / 2;
+	double y = (getHeight() - scale * image.getHeight()) / 2;
+	AffineTransform at = AffineTransform.getTranslateInstance(x, y);
+	if (flipV && !flipH) {
+	    at.scale(scale, -scale);
+	    at.translate(0, -getHeight() / 2);
+	} else if (flipH && !flipV) {
+	    at.scale(-scale, scale);
+	    at.translate(-getWidth() / 2, 0);
+	} else if (flipH && flipV) {
+	    at.scale(-scale, -scale);
+	    at.translate(-getWidth() / 2, -getHeight() / 2);
+	} else {
+	    at.scale(scale, scale);
+	}
+	System.out.println(scale);
+
+	g2.drawRenderedImage(image, at);
+
+    }
+
+    /* (non-Javadoc)
+     * @see javax.swing.JComponent#getPreferredSize()
+     */
+    public Dimension getPreferredSize() {
+	int w = (int) (scale * image.getWidth());
+	int h = (int) (scale * image.getHeight());
+	return new Dimension(w, h);
+    }
+
+    /**
+     * Récupération du slider
+     * @return le slider
+     */
+    public JSlider getSlider() {
+	int min = 1, max = 36, inc = 10;
+	final JSlider slider = new JSlider(min, max, 16);
+	slider.setMajorTickSpacing(5);
+	slider.setMinorTickSpacing(1);
+	slider.setPaintTicks(true);
+	slider.setSnapToTicks(true);
+	slider.setLabelTable(getLabelTable(min, max, inc));
+	slider.setPaintLabels(true);
+	slider.addChangeListener(new ChangeListener() {
+	    public void stateChanged(ChangeEvent e) {
+		int value = slider.getValue();
+		valueSlider = value;
+		scale = (value + 4) / 20.0;
+		revalidate();
+		repaint();
+	    };
+	});
+	return slider;
+    }
+
+    public void zoomIn() {
+
+	scale = (++valueSlider + 4) / 20.0;
+	revalidate();
+	repaint();
+    }
+
+    public void zoomOut() {
+
+	scale = (--valueSlider + 4) / 20.0;
+	revalidate();
+	repaint();
+    }
+
+    public void zoomNormal() {
+
+	scale = 1.0;
+	revalidate();
+	repaint();
+    }
+
+    /**
+     * Label du slider
+     * @param min
+     * @param max
+     * @param inc
+     * @return
+     */
+    private Hashtable getLabelTable(int min, int max, int inc) {
+	Hashtable<Integer, JLabel> table = new Hashtable<Integer, JLabel>();
+	for (int j = min; j <= max; j += inc) {
+	    String s = String.format("%.2f", (j + 4) / 20.0);
+	    table.put(Integer.valueOf(j), new JLabel(s));
+	}
+	return table;
+    }
+
+    /**
+     *  Rotation vers la droite
+     */
+    public void rotationDroite() {
+	setImage(ImagesUtil.rotate(image, Math.PI / 2));
+    }
+
+    /**
+     * Rotation vers la gauche
+     */
+    public void rotationGauche() {
+	setImage(ImagesUtil.rotate(image, -Math.PI / 2));
+    }
+
+    /**
+     * @return the image
+     */
+    public BufferedImage getImage() {
+	return image;
+    }
+
+    /**
+     * @param image the image to set
+     */
+    public void setImage(BufferedImage image) {
+	this.image = image;
+	revalidate();
+	repaint();
+    }
+
+    @Override
+    public void mouseWheelMoved(MouseWheelEvent arg0) {
+	int notches = arg0.getWheelRotation();
+	String message;
+	String newline = "\n";
+	if (notches < 0) {
+	    message = "Mouse wheel moved UP " + -notches + " notch(es)" + newline;
+	} else {
+	    message = "Mouse wheel moved DOWN " + notches + " notch(es)" + newline;
+	}
+	if (arg0.getScrollType() == MouseWheelEvent.WHEEL_UNIT_SCROLL) {
+	    message += "    Scroll amount: " + arg0.getScrollAmount() + " unit increments per notch" + newline;
+	    message += "    Units to scroll: " + arg0.getUnitsToScroll() + " unit increments" + newline;
+	} else { //scroll type == MouseWheelEvent.WHEEL_BLOCK_SCROLL
+	    message += "    Scroll type: WHEEL_BLOCK_SCROLL" + newline;
+	}
+
+    }
+
+    @Override
+    public int print(Graphics arg0, PageFormat arg1, int arg2) throws PrinterException {
+	if (arg2 != 0)
+	    return NO_SUCH_PAGE;
+	Graphics2D g2 = (Graphics2D) arg0;
+	g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
+	double x = (getWidth() - scale * image.getWidth()) / 2;
+	double y = (getHeight() - scale * image.getHeight()) / 2;
+	AffineTransform at = AffineTransform.getTranslateInstance(x, y);
+	if (flipV && !flipH) {
+	    at.scale(scale, -scale);
+	    at.translate(0, -getHeight() / 2);
+	} else if (flipH && !flipV) {
+	    at.scale(-scale, scale);
+	    at.translate(-getWidth() / 2, 0);
+	} else if (flipH && flipV) {
+	    at.scale(-scale, -scale);
+	    at.translate(-getWidth() / 2, -getHeight() / 2);
+	} else {
+	    at.scale(scale, scale);
+	}
+
+	g2.drawRenderedImage(image, at);
+	return PAGE_EXISTS;
+    }
+
+}
Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/mainframe/CategoriesTree.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/mainframe/CategoriesTree.java	(revision 6830)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/mainframe/CategoriesTree.java	(revision 6831)
@@ -106,8 +106,10 @@
      */
     public void setUpUi() {
+	//begin bug:0001830
 	root.removeAllChildren();
 	createNodes(root);
-	DefaultTreeModel model = (DefaultTreeModel) tree.getModel();
-	model.nodeStructureChanged(root);
+	((DefaultTreeModel) tree.getModel()).reload();
+	//end
+
     }
 
@@ -183,4 +185,7 @@
 	int selRow = tree.getRowForLocation(e.getX(), e.getY());
 	TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
+	//begin bug:0001832
+	tree.setSelectionRow(selRow);
+	//end
 	if (selRow != -1) {
 	    if (e.getButton() == 3) {
Index: extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/mainframe/MainFrame.java
===================================================================
--- extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/mainframe/MainFrame.java	(revision 6830)
+++ extensions/jiwigo/trunk/src/main/java/fr/mael/jiwigo/ui/mainframe/MainFrame.java	(revision 6831)
@@ -3,7 +3,12 @@
 import java.awt.BorderLayout;
 import java.awt.FlowLayout;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
 
 import javax.swing.JFrame;
 import javax.swing.JLabel;
+import javax.swing.JMenu;
+import javax.swing.JMenuBar;
+import javax.swing.JMenuItem;
 import javax.swing.JPanel;
 import javax.swing.JScrollPane;
@@ -42,5 +47,5 @@
  * Frame principale
  */
-public class MainFrame extends JFrame {
+public class MainFrame extends JFrame implements ActionListener {
     /**
      * Logger
@@ -60,5 +65,5 @@
      * Panel contenant les miniatures de la catégorie courante
      */
-    public static MiniaturesCategoryPanel imagesPanel;
+    public static ThumbnailCategoryPanel imagesPanel;
     /**
      *  Scrollpane contenant le panel ci dessus
@@ -69,4 +74,19 @@
      */
     private JLabel labelMessage;
+
+    /**
+     * Barre de menu
+     */
+    private JMenuBar jMenuBar;
+
+    /**
+     * Menu d'édition
+     */
+    private JMenu jMenuEdition;
+
+    /**
+     * menu des preferences
+     */
+    private JMenuItem jMenuItemPreferences;
 
     /**
@@ -92,9 +112,10 @@
 	this.setIconImage(java.awt.Toolkit.getDefaultToolkit().getImage(Outil.getURL("fr/mael/jiwigo/img/icon.png")));
 	this.setLayout(new BorderLayout());
+	jMenuBar = new JMenuBar();
 	labelMessage = new JLabel(Messages.getMessage("welcomeMessage"));
 	splitPane = new JSplitPane();
 	categoriesTree = new CategoriesTree();
 	splitPane.setLeftComponent(categoriesTree);
-	imagesPanel = new MiniaturesCategoryPanel(null);
+	imagesPanel = new ThumbnailCategoryPanel(null);
 	scrollPaneImagesPanel = new JScrollPane(imagesPanel, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
 		JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
@@ -104,4 +125,12 @@
 	JPanel panel = new JPanel(new FlowLayout(FlowLayout.LEFT));
 	panel.add(labelMessage);
+
+	jMenuEdition = new JMenu(Messages.getMessage("mainFrame_editionMenu"));
+	jMenuBar.add(jMenuEdition);
+	jMenuItemPreferences = new JMenuItem(Messages.getMessage("mainFrame_preferencesMenu"));
+	jMenuItemPreferences.addActionListener(this);
+	jMenuEdition.add(jMenuItemPreferences);
+
+	this.setJMenuBar(jMenuBar);
 	this.add(panel, BorderLayout.SOUTH);
 	this.pack();
@@ -134,3 +163,11 @@
     }
 
+    @Override
+    public void actionPerformed(ActionEvent arg0) {
+	if (arg0.getSource().equals(jMenuItemPreferences)) {
+	    new PreferencesDialog(this);
+	}
+
+    }
+
 }
